package org.blue.club.services;

import lombok.RequiredArgsConstructor;
import org.apache.commons.codec.digest.DigestUtils;
import org.blue.club.dao.UserDao;
import org.blue.club.entities.dto.User;
import org.blue.club.entities.dto.req.LoginRequest;
import org.blue.club.entities.vo.UserVo;
import org.mmga.spring.boot.starter.entities.Result;
import org.mmga.spring.boot.starter.utils.VoUtils;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

import static org.blue.club.entities.vo.table.UserVoTableDef.USER_VO;

@Service
@RequiredArgsConstructor
public class UserServices {
    private final UserDao userDao;
    private final VoUtils voUtils;

    public Result<User> login(LoginRequest loginRequest, String address) {
        UserVo userVo = userDao.selectOneWithRelationsByCondition(USER_VO.NAME.eq(loginRequest.username()).and(USER_VO.PASSWORD.eq(DigestUtils.sha1Hex(loginRequest.password()))));
        if (userVo == null) return Result.failed(HttpStatus.NOT_FOUND, "用户不存在！");
        User user = voUtils.vo2DtoSafe(userVo, User.class);
        return Result.success(user);
    }
}
